/*
 *	data.h
 */


#ifndef _DATA_H_
#define _DATA_H_

#define HEADER_TYPE_FIELD_WIDTH	(IMMEDIATE_TYPE_FIELD_WIDTH - 1)

#define MAKE_HEADER(type, length)	\
	MAKE_DESCRIPTOR(TAG_HEADER,	\
			(((length) << HEADER_TYPE_FIELD_WIDTH) | (type)))


#define HEADER_LENGTH_IN_CELLS(header)		\
	BYTES_TO_CELLS(header_length_in_bytes(header))

#define HEADER_AUNITS(h)		\
	BYTES_TO_AUNITS(header_length_in_bytes(h))


#define STOB_PAIR		0
#define STOB_SYMBOL		1
#define STOB_VECTOR		2
#define STOB_CLOSURE		3
#define STOB_CELL		4
#define STOB_PORT		5
#define STOB_RATIO		6
#define STOB_D_UNUSED_1		7

#define STOB_STRING		8
#define STOB_CODE_VECTOR	9
#define STOB_DOUBLE		10
#define STOB_BIGNUM		11

#define LEAST_B_VECTOR_TYPE	STOB_STRING

#define MAKE_STOB_DESCRIPTOR(memory_index)		\
	((CELL) &memory->data[(memory_index)] + TAG_STOB)


#define STOB_REF(stob, index)		\
	*((CELL *) address_after_header(stob) + (index))

#define STOB_SET(stob, index, value)	\
	(STOB_REF(stob, index) = value)


#define STOB_HEADER(stob)		STOB_REF((stob), -1)
#define STOB_HEADER_SET(stob, header)	STOB_SET((stob), -1, (header))

#define STOB_TYPE(obj)			header_type(STOB_HEADER(obj))
#define STOB_OF_TYPE_P(obj, type)	\
	(STOB_P(obj) && STOB_TYPE(obj) == (type))

#define VALID_INDEX_P(index, length)	\
	((index) >= 0 && (index) < (length))


#define D_VECTOR_HEADER_P(h)	(header_type(h) < LEAST_B_VECTOR_TYPE)
#define D_VECTOR_P(obj)		(STOB_P(obj)		 		\
				 && (header_type(STOB_HEADER(obj))	\
				     < LEAST_B_VECTOR_TYPE))

#define MAKE_D_VECTOR(type, length)	\
	make_stob((type), CELLS_TO_BYTES(length))


#define B_VECTOR_HEADER_P(h)	(HEADER_P(h)		\
				 && header_type(h) >= LEAST_B_VECTOR_TYPE)
#define B_VECTOR_P(obj)		(STOB_P(obj)				\
				 && (header_type(STOB_HEADER(obj))	\
				     >= LEAST_B_VECTOR_TYPE))

#define MAKE_B_VECTOR		make_stob

#endif
