/*
 *	memory.c
 */


#include <stdio.h>
#include "scheme.h"
#include "memory.h"

MEMORY *memory;				/* current VM memory in use */


/*
 *	Allocate space for a memory, if necessary, and then initialize it.
 */

MEMORY *
initialize_memory(size, initial_value)
int size;
int initial_value;
{
	static memory_created = FALSE;
	MEMORY *memory;

	if (! memory_created)
	{
		memory = create_memory(size);
		memory_created = TRUE;
	}
	memory->begin = 0;
	memory->end = size;
	fill_memory(memory, initial_value);
	return memory;
}


/*
 *	Allocate space for system memory.
 */

MEMORY *
create_memory(size)
int size;
{
	MEMORY *memory;
	extern char *malloc();

	if ((memory = (MEMORY *) malloc(sizeof (MEMORY))) == (MEMORY *) NULL)
		error("Could not allocate space for memory structure.");
	if ((memory->data = (int *) malloc((unsigned) size * sizeof(int)))
	    == (int *) NULL)
		error("Could not allocate memory space.");
	return memory;
}


/*
 *	Fill all of a memory with some initial value.
 */

void
fill_memory(memory, value)
MEMORY *memory;
int value;
{
	int i;

	for (i = memory->begin; i < memory->end; i++)
		memory->data[i] = value;
}
