/*
 *	memory.h
 */


#ifndef _MEMORY_H_
#define _MEMORY_H_

/*
 *  Memory for the virtual machine's heap.
 */
typedef struct
{
	int *data;			/* allocated memory space */
	int begin;			/* index of beginning of data */
	int end;			/* index of end of data */
} MEMORY;

extern MEMORY *memory;			/* current VM memory in use */

MEMORY *initialize_memory();		/* initialize memory system */
MEMORY *create_memory();		/* allocate space for a memory */
void fill_memory();			/* initialize all locations */

#endif
