/*
 *	scheme.h
 */


#ifndef _SCHEME_H_
#define _SCHEME_H_

#define NULL	0
#define TRUE	1
#define FALSE	0

/*
 *  Define ENDEDNESS to be 1 if your machine is little endian.  Define it
 *  to be 2 if your machine is big endian.
 */

#if defined(vax) || defined(ns32000)
#define ENDEDNESS	1
#else
#define ENDEDNESS	2
#endif


#ifdef DEBUG
#define assert(x)	(! (x) ? error("assertion failed") : 0)
#else
#define assert(x)
#endif


/*
 *  This version of Scheme-48 must be compiled with the GNU C compiler if
 *  one wants small routines to be expanded in place.  This could be done
 *  with macros, but then debugging the code would be more difficult.
 *  Ideally, I think the small routines should be written as m4 macros, so
 *  that GNU CC inline definitions, macros definitions, and separate function
 *  definitions could be generated from the same piece of code.
 */

#ifndef __GNUC__
#define inline
#endif

/*
 *  This implementation of Scheme 48 is designed to run on a byte addressable
 *  machine where a cell is four bytes.
 */
typedef int CELL;
typedef unsigned char BYTE;


#endif
