/*
 *	stack.c
 */


#include "scheme.h"
#include "arch.h"
#include "reg.h"
#include "data.h"
#include "struct.h"
#include "stack.h"


POP()
{
	int arg;

	arg = CAR(reg_stack);
	reg_stack = CDR(reg_stack);
	return arg;
}


POP_VECTOR(size)
int size;
{
	int v;

	v = reg_stack;
	assert(size == VECTOR_LENGTH(v) - 1);
	reg_stack = VECTOR_REF(reg_stack, size);
	return v;
}


PUSH_VECTOR_4(a1, a2, a3, a4)
int a1, a2, a3, a4;
{
	int temp;

	temp = MAKE_D_VECTOR(STOB_VECTOR, 5);
	d_vector_set(temp, 0, a1);
	d_vector_set(temp, 1, a2);
	d_vector_set(temp, 2, a3);
	d_vector_set(temp, 3, a4);
	d_vector_set(temp, 4, reg_stack);
	reg_stack = temp;
	return temp;
}


PUSH_VECTOR_7(a1, a2, a3, a4, a5, a6, a7)
int a1, a2, a3, a4, a5, a6, a7;
{
	int temp;

	temp = MAKE_D_VECTOR(STOB_VECTOR, 8);
	d_vector_set(temp, 0, a1);
	d_vector_set(temp, 1, a2);
	d_vector_set(temp, 2, a3);
	d_vector_set(temp, 3, a4);
	d_vector_set(temp, 4, a5);
	d_vector_set(temp, 5, a6);
	d_vector_set(temp, 6, a7);
	d_vector_set(temp, 7, reg_stack);
	reg_stack = temp;
	return temp;
}
