/*
 *	struct.h
 */


#ifndef _STRUCT_H_
#define _STRUCT_H_

char *extract_string();

/*
 *  Pairs
 */

#define PAIR_LENGTH		2

#define PAIR_P(obj)		STOB_OF_TYPE_P((obj), STOB_PAIR)
#define PAIR_SIZE		(PAIR_LENGTH + 1)
#define CAR(obj)		d_vector_ref((obj), 0)
#define CDR(obj)		d_vector_ref((obj), 1)
#define SET_CAR(obj, val)	d_vector_set((obj), 0, (val))
#define SET_CDR(obj, val)	d_vector_set((obj), 1, (val))


/*
 *  Symbols
 */

#define SYMBOL_LENGTH		1

#define SYMBOL_P(obj)		STOB_OF_TYPE_P((obj), STOB_SYMBOL)
#define SYMBOL_SIZE		(SYMBOL_LENGTH + 1)
#define SYMBOL_TO_STRING(obj)	d_vector_ref((obj), 0)


/*
 *  Closures
 */

#define CLOSURE_LENGTH		2
#define CLOSURE_P(obj)		STOB_OF_TYPE_P((obj), STOB_CLOSURE)
#define CLOSURE_SIZE		(CLOSURE_LENGTH + 1)
#define CLOSURE_TEMPLATE(obj)	d_vector_ref((obj), 0)
#define CLOSURE_ENV(obj)	d_vector_ref((obj), 1)


/*
 *  Cells
 */

#define CELL_LENGTH		3

#define CELL_P(obj)		STOB_OF_TYPE_P((obj), STOB_CELL)
#define CELL_SIZE		(CELL_LENGTH + 1)
#define CELL_CONTENTS(obj)	d_vector_ref((obj), 0)
#define CELL_NAME(obj)		d_vector_ref((obj), 1)
#define SET_CONTENTS(obj, val)	d_vector_set((obj), 0, (val))


/*
 *  Ports
 */

#define PORT_LENGTH		4


#define PORT_P(obj)		STOB_OF_TYPE_P((obj), STOB_PORT)
#define PORT_SIZE		(PORT_LENGTH + 1)
#define PORT_MODE(obj)		d_vector_ref((obj), 0)
#define PORT_INDEX(obj)		d_vector_ref((obj), 1)
#define PORT_PEEKED_CHAR(obj)	d_vector_ref((obj), 2)
#define PORT_ID(obj)		d_vector_ref((obj), 3)
#define SET_PORT_MODE(obj, val)	d_vector_set((obj), 0, (val))
#define SET_PORT_INDEX(obj, v)	d_vector_set((obj), 1, (v))
#define SET_PORT_PEEK(obj, val)	d_vector_set((obj), 2, (val))


/*
 *  Vectors
 */

#define MAKE_VECTOR(length)	MAKE_D_VECTOR(STOB_VECTOR, (length))
#define VECTOR_P(obj)		STOB_OF_TYPE_P((obj), STOB_VECTOR)
#define VECTOR_LENGTH		d_vector_length
#define VECTOR_REF		d_vector_ref
#define VECTOR_SET		d_vector_set

#define VECTOR_SIZE(length)	((length) + 1)

#define MAKE_CODE_VECTOR(len)	MAKE_B_VECTOR(STOB_CODE_VECTOR, (len))
#define CODE_VECTOR_P(obj)	STOB_OF_TYPE_P((obj), STOB_CODE_VECTOR)
#define CODE_VECTOR_LENGTH	b_vector_length
#define CODE_VECTOR_REF		b_vector_ref
#define CODE_VECTOR_SET		b_vector_set

#define CODE_VECTOR_SIZE(len)	(BYTES_TO_AUNITS(len) + 1)


/*
 *  Strings
 */

#define MAKE_STRING(length)	MAKE_B_VECTOR(STOB_STRING, (length))
#define STRING_P(obj)		STOB_OF_TYPE_P((obj), STOB_STRING)
#define STRING_LENGTH		b_vector_length
#define STRING_REF(str, i)	b_vector_ref((str), (i))
#define STRING_SET(str, i, val)	b_vector_set((str), (i), (val))
#define STRING_SIZE		CODE_VECTOR_SIZE
#define STRING_EQUAL_P		stob_equal_p

#endif
